#version 330 core 
in vec3 normal;
in vec3 lightDir;
in vec3 wPos;
in vec3 vColor;
in vec3 lColor;
in vec3 amb;
in vec3 dif;
in vec3 spec;
in float shine;
out vec4 color;

void main() {
	vec3 L = normalize(lightDir);
	vec3 N = normalize(normal);

	vec3 diffuseLight = max(dot(N, L), 0) * dif * lColor;
	vec3 H = normalize((wPos * -1 + L)/2);
	vec3 specularLight = pow(max(dot(H, N), 0), shine) * lColor * spec;
	vec3 ambientLight = amb * lColor;
	vec3 Ncolor = diffuseLight + specularLight + ambientLight;

	color = vec4(Ncolor, 1.0);
}
