#version 330 core
// Interpolated values from the vertex shaders
in vec3 fragColor;
in vec3 fragPos;
in vec2 aspt;
out vec4 color;

vec2 w2p(float x, float y) {
   return vec2((x + 1) * aspt.x/2, (y * aspt.x/aspt.y + 1) * aspt.y/2);
}

vec2 w2p(vec3 pos) {
   return w2p(pos.x, pos.y);
}

void main() {
   float radius = 8;
   float dist = distance(vec2(gl_FragCoord.x, gl_FragCoord.y), w2p(0, 0));
   float fragDist = distance(vec2(gl_FragCoord.x, gl_FragCoord.y), w2p(fragPos));
   if (dist < radius) {
      color = vec4(fragColor, 0) + vec4(vec3(1-fragDist/radius), .75);
   }
   else discard;
}
