#version  330 core
layout(location = 0) in vec4 vertPos;
layout(location = 1) in vec3 vertNor;
layout(location = 2) in vec3 vertTex;
uniform mat4 P;
uniform mat4 M;
uniform mat4 V;
uniform vec3 light;
uniform vec3 lightColor;
uniform vec3 MatAmb;
uniform vec3 MatDif;
uniform vec3 MatSpec;
uniform float MatShine;
uniform float disNorm;
out vec3 vColor;

void main() {
	vec3 L = normalize(light - (V * M * vertPos).xyz);
	vec3 N = normalize((V * M * vec4(vertNor, 0.0)).xyz);
	vec3 wPos = vertPos.xyz;
	vec3 nColor = disNorm == 1 ? (V * M * vec4(vertNor, 0.0)).xyz * 1.5 : vec3(1, 1, 1);

	vec3 diffuseLight = max(dot(N, L), 0) * MatDif * lightColor;
	vec3 H = normalize((wPos * -1 + L)/2);
	vec3 specularLight = pow(max(dot(H, N), 0), MatShine) * lightColor * MatSpec;
	vec3 ambientLight = MatAmb * lightColor;
	vColor = disNorm == 1 ? max(dot(N, L), 0) * nColor + ambientLight * nColor : diffuseLight + specularLight + ambientLight;

	gl_Position = P * V * M * vertPos;
}
