#version  330 core
layout(location = 0) in vec4 vertPos;
layout(location = 1) in vec3 vertNor;
uniform mat4 P;
uniform mat4 M;
uniform mat4 V;
uniform vec3 light;
uniform vec3 lightColor;
uniform vec3 MatAmb;
uniform vec3 MatDif;
uniform vec3 MatSpec;
uniform float MatShine;
uniform float disNorm;
out vec3 normal;
out vec3 lightDir;
out vec3 wPos;
out vec3 amb;
out vec3 dif;
out vec3 spec;
out float shine;
out vec3 lColor;

void main() {
	normal = (V * M * vec4(vertNor, 0.0)).xyz;
	lightDir = light - (V * M * vertPos).xyz;
	lColor = lightColor;
	vec3 nColor = disNorm == 1 ? normal * 1.5 : vec3(1, 1, 1);
	wPos = (V * M * vertPos).xyz;
	amb = MatAmb * nColor;
	dif = disNorm == 1 ? nColor : MatDif;
	spec = disNorm == 1 ? nColor : MatSpec;
	shine = MatShine;

	gl_Position = P * V * M * vertPos;
}
